package dev.shadowsoffire.apotheosis.adventure.net;

import net.minecraft.world.entity.player.Player;
import dev.shadowsoffire.placebo.network.MessageHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.effect.RadialAffix;
import net.minecraftforge.network.NetworkEvent;
import java.util.function.Supplier;
import net.minecraft.network.FriendlyByteBuf;
import dev.shadowsoffire.placebo.network.MessageProvider;

public class RadialStateChangeMessage
{
    public static class Provider implements MessageProvider<RadialStateChangeMessage>
    {
        public Class<?> getMsgClass() {
            return RadialStateChangeMessage.class;
        }
        
        public void write(final RadialStateChangeMessage msg, final FriendlyByteBuf buf) {
        }
        
        public RadialStateChangeMessage read(final FriendlyByteBuf buf) {
            return new RadialStateChangeMessage();
        }
        
        public void handle(final RadialStateChangeMessage msg, final Supplier<NetworkEvent.Context> ctx) {
            MessageHelper.handlePacket(() -> {
                final Player player = (Player)ctx.get().getSender();
                if (player != null) {
                    RadialAffix.toggleRadialState(player);
                }
            }, (Supplier)ctx);
        }
    }
}
